//*****************************************************************************
//
// @brief   SHA512 hash algorithm tests
// @author  Vadim Mezhlumov
//
//*****************************************************************************

#include "unity.h"
#include "crypt/sha512.h"
#include "misc/macros.h"
#include <string.h>
#include <new>


// ----------------------------------------------------------------------------
// Local variables
// ----------------------------------------------------------------------------

    TEST_GROUP(SHA512);

    // Testing object
    static IHash* g_pObj = NULL;

    // Tests data
    static const char* g_data[] =
    {
        "The quick brown fox jumps over the lazy dog",
        "abcdefghbcdefghicdefghijdefghijkefghijklfghijklmghijklmnhijklmnoijklmnopjklmnopqklmnopqrlmnopqrsmnopqrstnopqrstu",
        "0123456789",
        "abcdefghijklmnopqrstuvwxyz",
        "0123456789abcdefghijklmnopqrstuvwxyz",
        "0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789",
        "abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyz",
        "0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz"
    };

    // Test results
    static const char g_results[ARR_COUNT(g_data)][SHA512_DIGEST_LENGTH] =
    {
        {0x07,0xe5,0x47,0xd9,0x58,0x6f,0x6a,0x73,0xf7,0x3f,0xba,0xc0,0x43,0x5e,0xd7,0x69,0x51,0x21,0x8f,0xb7,0xd0,0xc8,0xd7,0x88,0xa3,0x09,0xd7,0x85,0x43,0x6b,0xbb,0x64,0x2e,0x93,0xa2,0x52,0xa9,0x54,0xf2,0x39,0x12,0x54,0x7d,0x1e,0x8a,0x3b,0x5e,0xd6,0xe1,0xbf,0xd7,0x09,0x78,0x21,0x23,0x3f,0xa0,0x53,0x8f,0x3d,0xb8,0x54,0xfe,0xe6},
        {0x8e,0x95,0x9b,0x75,0xda,0xe3,0x13,0xda,0x8c,0xf4,0xf7,0x28,0x14,0xfc,0x14,0x3f,0x8f,0x77,0x79,0xc6,0xeb,0x9f,0x7f,0xa1,0x72,0x99,0xae,0xad,0xb6,0x88,0x90,0x18,0x50,0x1d,0x28,0x9e,0x49,0x00,0xf7,0xe4,0x33,0x1b,0x99,0xde,0xc4,0xb5,0x43,0x3a,0xc7,0xd3,0x29,0xee,0xb6,0xdd,0x26,0x54,0x5e,0x96,0xe5,0x5b,0x87,0x4b,0xe9,0x09},
        {0xbb,0x96,0xc2,0xfc,0x40,0xd2,0xd5,0x46,0x17,0xd6,0xf2,0x76,0xfe,0xbe,0x57,0x1f,0x62,0x3a,0x8d,0xad,0xf0,0xb7,0x34,0x85,0x52,0x99,0xb0,0xe1,0x07,0xfd,0xa3,0x2c,0xf6,0xb6,0x9f,0x2d,0xa3,0x2b,0x36,0x44,0x5d,0x73,0x69,0x0b,0x93,0xcb,0xd0,0xf7,0xbf,0xc2,0x0e,0x0f,0x7f,0x28,0x55,0x3d,0x2a,0x44,0x28,0xf2,0x3b,0x71,0x6e,0x90},
        {0x4d,0xbf,0xf8,0x6c,0xc2,0xca,0x1b,0xae,0x1e,0x16,0x46,0x8a,0x05,0xcb,0x98,0x81,0xc9,0x7f,0x17,0x53,0xbc,0xe3,0x61,0x90,0x34,0x89,0x8f,0xaa,0x1a,0xab,0xe4,0x29,0x95,0x5a,0x1b,0xf8,0xec,0x48,0x3d,0x74,0x21,0xfe,0x3c,0x16,0x46,0x61,0x3a,0x59,0xed,0x54,0x41,0xfb,0x0f,0x32,0x13,0x89,0xf7,0x7f,0x48,0xa8,0x79,0xc7,0xb1,0xf1},
        {0x95,0xca,0xdc,0x34,0xaa,0x46,0xb9,0xfd,0xef,0x43,0x2f,0x62,0xfe,0x5b,0xad,0x8d,0x9f,0x47,0x5b,0xfb,0xec,0xf7,0x97,0xd5,0x80,0x2b,0xb5,0xf2,0x93,0x7a,0x85,0xd9,0x3c,0xe4,0x85,0x7a,0x62,0x62,0xb0,0x38,0x34,0xc0,0x1c,0x61,0x0d,0x74,0xcd,0x12,0x15,0xf9,0xa4,0x66,0xdc,0x6a,0xd3,0xdd,0x15,0x07,0x8e,0x33,0x09,0xa0,0x3a,0x6d},
        {0xe1,0x12,0x17,0x4a,0x3d,0x75,0x7a,0xcc,0xe7,0x80,0xe4,0xea,0x34,0x01,0xba,0x80,0x59,0x93,0x98,0x8b,0x9e,0x90,0x80,0x4d,0xde,0x2f,0x03,0x94,0xcd,0xda,0x9e,0x42,0x4a,0x5f,0xc1,0x10,0x89,0xf9,0xbb,0x9f,0x73,0x15,0xac,0x0b,0xb3,0x41,0xfb,0x30,0x23,0xc5,0xbe,0xab,0x61,0x93,0x12,0x74,0x6c,0x3e,0x19,0x38,0x66,0xd9,0xdd,0xbc},
        {0xf5,0x9f,0x92,0x3e,0x98,0xf9,0x23,0x19,0x28,0x53,0xb6,0xa5,0xa0,0x3f,0x58,0xbb,0x6a,0x86,0xf9,0xb8,0x43,0xc4,0x35,0x2b,0x4d,0x71,0xc2,0x92,0x1b,0x90,0x59,0x39,0x66,0xad,0x9e,0xf4,0xbe,0xa6,0x50,0xdb,0xb4,0xeb,0xe2,0x17,0x0b,0x80,0x7e,0xa1,0xab,0xb6,0xf3,0xcf,0x54,0x90,0x81,0xff,0xb9,0x81,0xc2,0xc2,0x3f,0x88,0x6d,0x07},
        {0x54,0x61,0x6b,0x72,0x67,0xa3,0xd9,0x12,0x27,0x4b,0x73,0xcf,0xc8,0x53,0x89,0x8f,0x3a,0x99,0xe8,0x85,0xf8,0x94,0xa6,0x33,0x47,0x3e,0xb3,0xc0,0x47,0xfb,0x65,0xd3,0xd5,0x59,0x27,0x31,0x51,0x38,0xc0,0x66,0x5d,0xf6,0xc9,0x9f,0x7b,0x56,0x09,0xf5,0xb0,0x2e,0xf0,0x53,0x78,0x8e,0x40,0xfa,0x94,0xff,0xbf,0x38,0x2a,0x3d,0x65,0x4f}
    };


/**
  * @brief  Test group runner
  * @param  Test group name
  */
TEST_GROUP_RUNNER(SHA512)
{
    RUN_TEST_CASE(SHA512, wrongParamsCalc);
    RUN_TEST_CASE(SHA512, wrongParamsAppend);
    RUN_TEST_CASE(SHA512, wrongParamsGetResult);
    RUN_TEST_CASE(SHA512, CalculateFull);
    RUN_TEST_CASE(SHA512, CalculatePartial);
}


/**
  * @brief  Test initialization (for each test)
  * @param  Test group name
  */
TEST_SETUP(SHA512)
{
    g_pObj = new CSha512();
    CHECK(g_pObj != NULL);
    g_pObj->Reset();
}


/**
  * @brief  Test deinitialization (for each test)
  * @param  Test group name
  */
TEST_TEAR_DOWN(SHA512)
{
    if (g_pObj)
    {
        delete g_pObj;
        g_pObj = NULL;
    }
}


/**
  * @brief  Test
  * @param  Test group name
  * @param  Test name
  */
TEST(SHA512, wrongParamsCalc)
{
    int result = g_pObj->Calculate(NULL, 1, 1);
    CHECK(result < 0);

    result = g_pObj->Calculate(g_data[0], 0, 0);
    CHECK(result < 0);

    result = g_pObj->Calculate(g_data[0], 1, 0);
    CHECK(result < 0);
}


/**
  * @brief  Test
  * @param  Test group name
  * @param  Test name
  */
TEST(SHA512, wrongParamsAppend)
{
    int result = g_pObj->Append(NULL, 1);
    CHECK(result < 0);

    result = g_pObj->Append(g_data[0], 0);
    CHECK(result < 0);
}


/**
  * @brief  Test
  * @param  Test group name
  * @param  Test name
  */
TEST(SHA512, wrongParamsGetResult)
{
    int result = g_pObj->GetResult(NULL, 1);
    CHECK(result < 0);

    char buff[1];
    result = g_pObj->GetResult(buff, 0);
    CHECK(result < 0);
}


/**
  * @brief  Test
  * @param  Test group name
  * @param  Test name
  */
TEST(SHA512, CalculateFull)
{
    char hash[SHA512_DIGEST_LENGTH];

    for (uint i = 0; i < ARR_COUNT(g_data); ++i)
    {
        memset( hash, 0x00, sizeof(hash) );
        g_pObj->Reset();

        const char* str = g_data[i];
        uint len = strlen(str);
        int result = g_pObj->Calculate(str, len, len);
        LONGS_EQUAL(len, result);

        result = g_pObj->GetResult( hash, sizeof(hash) );
        LONGS_EQUAL(sizeof(hash), result);

        bool isCorrect = ( !memcmp(hash, g_results[i], result) );
        CHECK(isCorrect);
    }
}


/**
  * @brief  Test
  * @param  Test group name
  * @param  Test name
  */
TEST(SHA512, CalculatePartial)
{
    char hash[SHA512_DIGEST_LENGTH];

    for (uint i = 0; i < ARR_COUNT(g_data); ++i)
    {
        memset( hash, 0x00, sizeof(hash) );
        g_pObj->Reset();

        const char* str = g_data[i];
        uint totalLen = strlen(str);

        // Skip data less than one block (only partial calculation)
        if (totalLen <= SHA512_BLOCK_SIZE) continue;

        int result = g_pObj->Calculate(str, 1, totalLen);
        CHECK(!result);

        result = g_pObj->Calculate(str, SHA512_BLOCK_SIZE - 1, totalLen);
        CHECK(!result);

        result = g_pObj->Calculate(str, SHA512_BLOCK_SIZE, totalLen);
        LONGS_EQUAL(SHA512_BLOCK_SIZE, result);

        totalLen -= SHA512_BLOCK_SIZE;
        str += SHA512_BLOCK_SIZE;

        uint partLen = 0;
        while (totalLen)
        {
            ++partLen;
            CHECK(partLen <= totalLen);

            result = g_pObj->Append(str, partLen);
            if (!result)
            {
                CHECK(partLen < SHA512_BLOCK_SIZE);
                continue;
            }

            CHECK(result > 0);
            LONGS_EQUAL(partLen, result);

            totalLen -= partLen;
            str += partLen;
            partLen = 0;

            // Check calculation result
            if (!totalLen)
            {
                result = g_pObj->GetResult( hash, sizeof(hash) );
                LONGS_EQUAL(sizeof(hash), result);

                bool isCorrect = ( !memcmp(hash, g_results[i], result) );
                CHECK(isCorrect);
                break;
            }
        } // while (totalLen)
    } // for (uint i = 0; i < ARR_COUNT(g_data); ++i)
}
